/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.alibaba.fastjson2.JSONObject
 *  com.ruoyi.common.core.web.controller.BaseController
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.common.core.web.page.TableDataInfo
 *  com.ruoyi.common.log.annotation.Log
 *  com.ruoyi.common.log.enums.BusinessType
 *  com.ruoyi.common.security.annotation.RequiresPermissions
 *  com.ruoyi.system.controller.SnClientVersionController
 *  com.ruoyi.system.domain.SnTemplate
 *  com.ruoyi.system.domain.SysConfig
 *  com.ruoyi.system.service.ISnTemplateService
 *  com.ruoyi.system.service.ISysConfigService
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.web.bind.annotation.DeleteMapping
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.ruoyi.system.controller;

import com.alibaba.fastjson2.JSONObject;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.system.domain.SnTemplate;
import com.ruoyi.system.domain.SysConfig;
import com.ruoyi.system.service.ISnTemplateService;
import com.ruoyi.system.service.ISysConfigService;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Collections;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value={"/SnClientVersion"})
public class SnClientVersionController
extends BaseController {
    @Autowired
    private ISnTemplateService snTemplateService;
    @Autowired
    private ISysConfigService configService;

    @GetMapping(value={"/version"})
    public AjaxResult version() {
        JSONObject json = new JSONObject();
        json.put((Object)"backVersion", (Object)this.configService.selectConfigByKey("sync-client-version"));
        json.put((Object)"uaVersion", (Object)this.configService.selectConfigByKey("client-ua-version"));
        return AjaxResult.success((String)"获取成功", (Object)json);
    }

    @GetMapping(value={"/list"})
    public TableDataInfo list(SnTemplate snTemplate) {
        this.startPage();
        if (snTemplate.getCategory() != 0 && snTemplate.getCategory() != 1) {
            TableDataInfo rspData = new TableDataInfo();
            rspData.setCode(200);
            rspData.setRows(Collections.emptyList());
            rspData.setMsg("查询成功");
            rspData.setTotal(0L);
            return rspData;
        }
        List list = this.snTemplateService.selectSnTemplateList(snTemplate);
        return this.getDataTable(list);
    }

    @RequiresPermissions(value={"system:clientVersion:query"})
    @GetMapping(value={"/{templateId}"})
    public AjaxResult getInfo(@PathVariable(value="templateId") Long templateId) {
        return this.success((Object)this.snTemplateService.selectSnTemplateByTemplateId(templateId));
    }

    @RequiresPermissions(value={"system:clientVersion:add"})
    @Log(title="客户端版本", businessType=BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody SnTemplate snTemplate) {
        if (snTemplate.getCategory() == null || snTemplate.getCategory() != 0 && snTemplate.getCategory() != 1) {
            return this.error("分类参数有误");
        }
        snTemplate.setStatus(Integer.valueOf(1));
        int num = this.snTemplateService.insertSnTemplate(snTemplate);
        SysConfig config = this.configService.selectConfigByKeyObj("sync-client-version");
        if (config == null) {
            return AjaxResult.error((String)"更新客户端版本失败");
        }
        BigDecimal version = new BigDecimal(config.getConfigValue()).add(new BigDecimal("0.01")).setScale(2, RoundingMode.HALF_EVEN);
        config.setConfigValue(version.toString());
        this.configService.updateConfig(config);
        return this.toAjax(num);
    }

    @RequiresPermissions(value={"system:clientVersion:edit"})
    @Log(title="客户端版本", businessType=BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody SnTemplate snTemplate) {
        return this.toAjax(this.snTemplateService.updateSnTemplate(snTemplate));
    }

    @RequiresPermissions(value={"system:clientVersion:remove"})
    @Log(title="客户端版本", businessType=BusinessType.DELETE)
    @DeleteMapping(value={"/{templateIds}"})
    public AjaxResult remove(@PathVariable Long[] templateIds) {
        return this.snTemplateService.deleteSnTemplateByTemplateIds(templateIds);
    }
}

